import Foundation
import HealthKit

extension HKWorkoutActivity: Comparable {

    public static func < (lhs: HKWorkoutActivity, rhs: HKWorkoutActivity) -> Bool {
        lhs.startDate < rhs.startDate
    }
}

extension HKWorkoutActivity {

    var externalUUID: UUID? {
        guard let string = metadata?[HKMetadataKeyExternalUUID] as? String else {
            return nil
        }
        return UUID(uuidString: string)
    }
}
